// CIniSampleDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "CIniSample.h"
#include "CIniSampleDlg.h"

#include "Ini2.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCIniSampleDlg Dialogfeld

CCIniSampleDlg::CCIniSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCIniSampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCIniSampleDlg)
	m_nInt = 0;
	m_dDouble = 0.0;
	m_strString = _T("");
	m_strIniFile = _T("Sample.ini");
	m_nAddModul = 0;
	m_strIniFileUsed = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCIniSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCIniSampleDlg)
	DDX_Text(pDX, IDC_EDIT_INT, m_nInt);
	DDX_Text(pDX, IDC_EDIT_DOUBLE, m_dDouble);
	DDX_Text(pDX, IDC_EDIT_STRING, m_strString);
	DDX_Text(pDX, IDC_EDIT_INIFILE, m_strIniFile);
	DDX_Radio(pDX, IDC_RADIO_MODUL_0, m_nAddModul);
	DDX_Text(pDX, IDC_EDIT_INIFILE_USED, m_strIniFileUsed);
	//}}AFX_DATA_MAP
   DDX_Text(pDX,IDC_EDIT_PT_X,m_ptPoint.x);
   DDX_Text(pDX,IDC_EDIT_PT_Y,m_ptPoint.y);
   DDX_Text(pDX,IDC_EDIT_AR_0,m_arInt[0]);
   DDX_Text(pDX,IDC_EDIT_AR_1,m_arInt[1]);
}

BEGIN_MESSAGE_MAP(CCIniSampleDlg, CDialog)
	//{{AFX_MSG_MAP(CCIniSampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_UPDATE_TRUE, OnButtonUpdateTrue)
	ON_BN_CLICKED(IDC_BUTTON_UPDATE_FALSE, OnButtonUpdateFalse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCIniSampleDlg Nachrichten-Handler

BOOL CCIniSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
   GetWindowRect(m_Rect);
   UpdateIni();  //Read from Ini
   UpdateData(FALSE);//Fill the DlgControls
   if( m_Rect.Height() > 50 && m_Rect.Width() > 50)
      MoveWindow(m_Rect);
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CCIniSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CCIniSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CCIniSampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCIniSampleDlg::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}

void CCIniSampleDlg::OnButtonUpdateTrue() 
{
   UpdateData();
   UpdateIni();
   MoveWindow(m_Rect);
   UpdateData(FALSE);
}

void CCIniSampleDlg::OnButtonUpdateFalse() 
{
   UpdateData();
   GetWindowRect(m_Rect);
   UpdateIni(FALSE);
   UpdateData(FALSE);
}

void CCIniSampleDlg::UpdateIni(BOOL bFromIni /*=TRUE*/)
{
   CIni ini( m_strIniFile, "Section", (m_nAddModul==0) );
   ini.SER_GET(bFromIni,m_nInt);
   ini.SER_GETD(bFromIni,m_dDouble,9.8);
   ini.SER_GETD(bFromIni,m_strString,"Hello");
   ini.SER_GET(bFromIni,m_ptPoint);
   ini.SER_ARR(bFromIni,m_arInt,2);

   ini.SetSection("Rect");
   ini.SER_GETD(bFromIni,m_Rect,m_Rect); //m_Rect=Default
 
   m_strIniFileUsed = ini.GetFileName();
}
